﻿Imports System.IO
Imports System.Net
Imports System.Text
Imports Json.Net

Public Class FrmAdmin
   'Private ServiceHost As String = "192.168.178.99"
   Private ServiceHost As String = "192.168.178.43"
   Private ServicePort As Integer = 8082
   Private DB As SortedDictionary(Of String, String)
   Private LoadCompleted As Boolean = False

   Private Sub lblAbout_Click(sender As Object, e As EventArgs) Handles lblAbout.Click
      Dim f As New AboutBox
      f.ShowDialog()
   End Sub

   Private Sub AddRow(Key As String, Value As String)
      Dim row As DataGridViewRow = New DataGridViewRow()
      row.CreateCells(GridDB)
      row.Cells(0).Value = Key
      row.Cells(1).Value = Value
      row.Cells(2).Value = "Löschen"
      GridDB.Rows.Add(row)
   End Sub

   Private Sub FrmAdmin_Load(sender As Object, e As EventArgs) Handles MyBase.Load
      LblServiceAddress.Text = ServiceHost & ":" & ServicePort
      SaveGridDimensions()
      LoadCompleted = True
   End Sub

   Private Sub CmdLoad_Click(sender As Object, e As EventArgs) Handles CmdLoad.Click
      Dim result As String = ""

      GridDB.Rows.Clear()

      Dim webClient As New WebClient
      webClient.Encoding = Encoding.UTF8
      Try
         result = webClient.DownloadString("http://" & ServiceHost & ":" & ServicePort & "/getall")
      Catch ex As Exception
         Dim Prompt = "Der UrsTinyWebDB-Service hat nicht korrkt geantwortet:" & vbCrLf & ex.Message
         MsgBoxEx(Prompt, UrsExtendedMsgBox.MsgTypes.Error,,,,,, True)
         Return
      End Try
      Dim db = JsonNet.Deserialize(Of SortedDictionary(Of String, String))(result)

      For Each key In db.Keys
         AddRow(key, db.Item(key))
      Next
   End Sub

   Private Sub GridDB_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles GridDB.CellContentClick
      If e.ColumnIndex <> 2 Then
         Return
      End If

      Dim key = CStr(GridDB.Rows(e.RowIndex).Cells(0).Value)
      Dim value = CStr(GridDB.Rows(e.RowIndex).Cells(1).Value)
      Dim Prompt = "Datensatz löschen: " & key & "=" & value

      Dim rtc = MsgBoxEx(Prompt, UrsExtendedMsgBox.MsgTypes.Question, , UrsExtendedMsgBox.ButtonList.OkCancel, UrsExtendedMsgBox.DefaultButtons.Button2)

      If Not (vbOK = rtc) Then
         Return
      End If

      Dim request As WebRequest = CType(WebRequest.Create("http://" & ServiceHost & ":" & ServicePort & "/storeavalue"), HttpWebRequest)
      request.Method = "POST"
      request.ContentType = "application/x-www-form-urlencoded"
      Dim postData = "tag=" & WebUtility.UrlEncode(key) & "&value=" & WebUtility.UrlEncode("""*delete*""")

      Dim byteArray = Encoding.UTF8.GetBytes(postData)
      request.ContentLength = byteArray.Length
      Dim dataStream As Stream = Nothing
      Dim response As WebResponse = Nothing

      Try
         dataStream = request.GetRequestStream()
         dataStream.Write(byteArray, 0, byteArray.Length)
         dataStream.Close()
         response = request.GetResponse()
      Catch ex As Exception
         Prompt = "Der UrsTinyWebDB-Service hat nicht korrkt geantwortet:" & vbCrLf & ex.Message
         MsgBoxEx(Prompt, UrsExtendedMsgBox.MsgTypes.Error,,,,,, True)
         Try
            dataStream.Close()
         Catch
         End Try
         Try
            response.Close()
         Catch
         End Try
         Return
      End Try
      dataStream = response.GetResponseStream()
      Dim reader = New StreamReader(dataStream)
      Dim responseFromServer = reader.ReadToEnd()
      reader.Close()
      dataStream.Close()
      response.Close()

      If Not responseFromServer.StartsWith("[""DELETED""") Then
         Prompt = "Fehler beim Löschen. Response ist:" & vbCrLf & responseFromServer
         MsgBoxEx(Prompt, UrsExtendedMsgBox.MsgTypes.Error)
         Return
      End If
      GridDB.Rows.RemoveAt(e.RowIndex)
   End Sub

   Private Sub GridDB_SelectionChanged(sender As Object, e As EventArgs) Handles GridDB.SelectionChanged
      GridDB.ClearSelection()
   End Sub

#Region " Resize "
   Private ColumnKeyWith As Integer
   Private ColumnValueWith As Integer
   Private ColumnOtherWith As Integer
   Private ColumnsStartSize As Integer

   Private FormResizing As Boolean = False

   Private Sub SaveGridDimensions()
      ColumnKeyWith = GridDB.Columns(0).Width
      ColumnValueWith = GridDB.Columns(1).Width
      ColumnsStartSize = ColumnKeyWith + ColumnValueWith
      ColumnOtherWith = GridDB.Width - ColumnKeyWith - ColumnValueWith
   End Sub

   Private Sub FrmAdmin_ResizeBegin(sender As Object, e As EventArgs) Handles Me.ResizeBegin
      SaveGridDimensions()
      FormResizing = True
   End Sub

   Private Sub FrmAdmin_ResizeEnd(sender As Object, e As EventArgs) Handles Me.ResizeEnd
      SaveGridDimensions()
      FormResizing = False
   End Sub

   Private Sub FrmAdmin_Resize(sender As Object, e As EventArgs) Handles Me.Resize
      If Not LoadCompleted Then
         Return
      End If

      Dim TotalColumnSize As Single = GridDB.Width - ColumnOtherWith
      GridDB.Columns(0).Width = CInt(TotalColumnSize / ColumnsStartSize * ColumnKeyWith)
      GridDB.Columns(1).Width = CInt(TotalColumnSize / ColumnsStartSize * ColumnValueWith)
   End Sub

   Private Sub GridDB_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles GridDB.ColumnWidthChanged
      If Not LoadCompleted OrElse FormResizing Then
         Return
      End If

      If GridDB.Columns(0).Width > ColumnsStartSize - GridDB.Columns(1).MinimumWidth Then
         GridDB.Columns(0).Width = ColumnsStartSize - GridDB.Columns(1).MinimumWidth
      End If
      GridDB.Columns(1).Width = ColumnsStartSize - GridDB.Columns(0).Width
   End Sub
#End Region
End Class
